/*
 * (C) Copyright Ian D. Romanick 2007
 * All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * on the rights to use, copy, modify, merge, publish, distribute, sub
 * license, and/or sell copies of the Software, and to permit persons to whom
 * the Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT.  IN NO EVENT SHALL
 * AUTHORS, COPYRIGHT HOLDERS, AND/OR THEIR SUPPLIERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
 * USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

varying vec3 light_dir;
varying vec3 eye_pos;

attribute vec3 tangent;

void main(void)
{
    vec3 vert_pos = vec3(gl_ModelViewMatrix * gl_Vertex);

    gl_Position = ftransform();
    gl_TexCoord[0].st = gl_Vertex.xz * gl_NormalScale;
    gl_FrontColor = gl_Color;

#if 1
    vec3 t = normalize(gl_NormalMatrix * tangent);
    vec3 n = normalize(gl_NormalMatrix * gl_Normal);
#else
    vec3 t = (gl_NormalMatrix * tangent);
    vec3 n = (gl_NormalMatrix * gl_Normal);
#endif
    vec3 b = cross(n, t);

    vec3 v;

    vec3 light = gl_LightSource[0].position.xyz - vert_pos;
    v.x = dot(light, t);
    v.y = dot(light, b);
    v.z = dot(light, n);
    light_dir = normalize(v);

    vec3 ep = -vert_pos;
    v.x = dot(ep, t);
    v.y = dot(ep, b);
    v.z = dot(ep, n);
    eye_pos = v;
}
